const fs = require('fs');

const props = new Map();
const UnicodeTrieBuilder = require('unicode-trie/builder');

const builder = new UnicodeTrieBuilder(0, 0);

function parse() {
  const lines = fs.readFileSync('UNIDATA/extracted/DerivedCombiningClass.txt', 'utf8').split(/\n/);
  let match;
  let propIndex = 0;
  for (const line of lines) {
    let match;
    if (/^#/.test(line) || /^\s*$/.test(line)) {
    } else if (match = /^(\w+)\s*;\s*(\w+)\s*#.*$/.exec(line)) {
      if (parseInt(match[2]) !== 0) {
        //console.log('setting', parseInt(match[1], 16), parseInt(match[2]));
        builder.set(parseInt(match[1], 16), parseInt(match[2]));
      }
    } else if (match = /^(\w+)\s*\.\.\s*(\w+)\s*;\s*(\w+)\s*#.*$/.exec(line)) {
      if (parseInt(match[3]) !== 0) {
        //console.log('setting', parseInt(match[1], 16), parseInt(match[2]), parseInt(match[3]));
        builder.setRange(parseInt(match[1], 16), parseInt(match[2], 16), parseInt(match[3]));
      }
    }
  }
}

parse();

let t = builder.freeze();
fs.writeFileSync('ccc.trie', builder.toBuffer());
